'******************************************  *************************************
'****                                  ****  ****                             ****
'**** PROGRAM REJESTRATORA TEMPERATURY ****  ****     MAPA PAMIECI EEPROM     ****
'****                                  ****  ****                             ****
'**** Autor: Piotr Wilk                ****  **** 00-hoff                     ****
'****        piotr.wilk@poczta.fm      ****  **** 01-moff                     ****
'****                                  ****  **** 02-|adres ostatniej komorki ****
'****                                  ****  **** 03-|adresrej                ****
'****                                  ****  ****                             ****
'****                                  ****  **** 06-miesiac                  ****
'**** Rozmiar: 3760B                   ****  **** 07-dzien                    ****
'**** Ver 2.0                          ****  **** 08-godzina poczatku zapisu  ****
'****                                  ****  **** 09-minuta poczatku zapisu   ****
'******************************************  *************************************

$large
$crystal = 11059200
$baud = 4800
Config Scl = P2.6
Config Sda = P2.7
Config 1wire = P0.7
Config Timer0 = Timer , Gate = Internal , Mode = 1            'wyswietacze
Counter0 = 61500                                              'WYSWIETLACZE
On Timer0 Timer0_int
Enable Interrupts
Enable Timer0
Start Timer0                                                  'START TIMERA CZASU

Dim Flag As Bit                                               'przelaczanie czas/temp
Dim Oo1 As Bit                                                'jednokrotny pomiar T na 5 s.
Dim Oo2 As Bit                                                'jednokrotny zapis T do EEPROM
Dim Rejestruj As Bit                                          'rejestracja
Dim Datetime As Bit                                           'zapisywanie czasu i daty w EEPROM
Dim Adresrej As Integer                                       'adres ostatniej rejestracji w EEPROM
Dim T As Integer                                              'temperatura
Dim Rsbuf As Integer                                          'bufor transmisji szeregowej
Dim H1 As Byte                                                '|zmienne uzywane przy skladania wartosci integer
Dim H2 As Byte                                                '|do bufora RS232
Dim Disp1 As Byte                                             'pierwszy wyswietlacz
Dim Disp2 As Byte                                             'drugi wyswietlacz
Dim Disp3 As Byte                                             'trzeci wyswietlacz
Dim Disp4 As Byte                                             'czwarty wyswietlacz
Dim Bufor As Byte                                             'bufor wyswietlaczy
Dim X As Byte                                                 'licznik przy obsludze wyswietlaczy
Dim Adres As Integer                                          'adres wysylanego bajtu do EEPROM
Dim Wartosc As Byte                                           'wartosc wysylanego bajtu do EEPROM
Dim H As Byte                                                 'godzina
Dim M As Byte                                                 'minuta
Dim S As Byte                                                 'sekunda
Dim Day As Byte                                               'dzien
Dim Month As Byte                                             'miesiac
Dim Hon As Byte                                               'godzina wlaczenia
Dim Mon As Byte
Dim Hoff As Byte                                              'godzina wylaczenia
Dim Moff As Byte
Dim Tmp1 As Integer                                           '|
Dim Tmp2 As Integer                                           '|pomocnicze przy wyswietlaniu temperatury
Dim T1 As Integer                                             'pomocnicza przy obliczaniu temperatury
Dim Count1 As Byte                                            '|
Dim Count2 As Byte                                            '|liczniki pomocnicze
Dim Bd(9) As Byte                                             'pomocnicze przy liczeniu temperatury

Declare Sub Writee                                            'zapis do EEPROM
Declare Sub Reade                                             'odczyt z EEPROM
Declare Sub 7seg                                              'odczyt tablicy z kodami cyfr
Declare Sub Waiting                                           'opoznienie
Declare Sub Shortwait                                         'opoznienie
Declare Sub Longwait                                          'opoznienie
Declare Sub Demo                                              'kreski na disp
Declare Sub Gettime                                           'czyta z PCF-a
Declare Sub Showtime                                          'pokazuje czas
Declare Sub Set_date                                          'ustaianie daty
Declare Sub Set_time                                          'ustawianie czasu
Declare Sub Set_time_on                                       'ustawianie godziny wlaczenia
Declare Sub Showsettings                                      'pokazanie czasu wlaczenia i wylaczenia rej.
Declare Sub Gettemp                                           'pobranie temp z czujnika
Declare Sub Showtemp                                          'wyswietlenie temperatury
Declare Sub Read1820                                          'odczyt czujnika
Declare Sub Reg                                               'zapis temperatury
Declare Sub Senddata                                          'wysylanie danych do PC
Declare Sub Sendtemp                                          'wysylanie do PC samej temperatury

Anoda1 Alias P3.2
Anoda2 Alias P3.3
Anoda3 Alias P3.4
Anoda4 Alias P3.5
Degree Alias P3.6

Dot Alias P2.5
Dotdegree Alias P2.4
Ledreg Alias P3.7

Up Alias P2.3
Down Alias P2.2
Ok Alias P2.1
Mode1 Alias P2.0

'*********************************************************************************
Adres = 0 : Reade : Hoff = Wartosc                            'zczytanie wartosci z EEPROM
Adres = 1 : Reade : Moff = Wartosc
Adres = 2 : Reade : Poke 34 , Wartosc                         'wpisanie do ramu wartosci
Adres = 3 : Reade : Poke 35 , Wartosc                         'ostatnie komorki z danymi
Adres = 8 : Reade : Hon = Wartosc
Adres = 9 : Reade : Mon = Wartosc

Rejestruj = 0                                                 'wyzerowanie-brak rejestracji
Datetime = 1                                                  'ustawienie flagi-zapis czasu i daty na poczatku
Oo2 = 1                                                       'zapis tylko raz
'\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
'\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ PETLA GLOWNA \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
'\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
Main:
Flag = 1
Oo1 = 1
Do

If S = 10 Then : Flag = 0 : End If
If S = 30 Then : Flag = 0 : End If
If S = 50 Then : Flag = 0 : End If

If Flag = 0 Then
   Gettime
   If S = 20 Then : Flag = 1 : End If
   If S = 40 Then : Flag = 1 : End If
   If S = 59 Then : Flag = 1 : End If
     If Oo1 = 1 Then
        Gettemp
        Oo1 = 0
     End If
   Showtemp
End If

If Flag = 1 Then
   Oo1 = 1
   Degree = 1
   Dotdegree = 1
   Gettime
   Showtime
   If Count2 > 120 Then                                       'miganie kropek
      Count2 = 0
      Dot = Not Dot
   End If
End If

If Ok = 0 Then                                                'pokaz temperature
   Waiting                                                    'opoznienie
   Gettemp                                                    'pobierz temp
   Showtemp                                                   'pokaz temperature
   Longwait                                                   '2 sekundy
   Degree = 1                                                 'wylaczenie stopni c
   Dotdegree = 1                                              'wylacz przecinek
End If

If Mode1 = 0 Then                                             'wejscie do menu
   Waiting
   Goto Menu
End If

If Up = 0 Then                                                'pokazuje czas wlaczenia i wylaczenia rejestracji
   Waiting
   Showsettings
End If

If Down = 0 Then                                              'wlaczanie/wylaczanie rejestracji
   Waiting : Waiting

   If Rejestruj = 0 Then                                      'jesli bit wlaczajacy wyzerowany
      Rejestruj = 1                                           'ustaw bit
      Ledreg = 0                                              'wlaczenie diody
   Else
      Ledreg = 1
      Rejestruj = 0
      Datetime = 1
   End If
End If

If Rejestruj = 1 Then                                         'jesli ustawiona flaga to rejestruj temperature
   Reg
End If

Rsbuf = Inkey                                                 '|
                                '|
      If Rsbuf = 1 Then                                       '|jesli odebrano z PC-ta 1 wyslij dane z eeproma
         Senddata                                             '|
      End If                                                  '|
                                '|
      If Rsbuf = 2 Then                                       '|jesli odebrano z PC-ta 2 wyslij aktualna temp
         Sendtemp                                             '|
      End If                                                  '|
                                '|
      If Rsbuf = 3 Then                                       '|czy uklad podlaczony??
         Rsbuf = 3                                            '|odpowiedz dla PC
         Printbin Rsbuf;                                      '|
      End If                                                  '|

Loop                                                          'koniec petli glownej

End
'/////////////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////////////
Menu:                                                         'MENU
Dotdegree = 1
Degree = 1
Dot = 1                                                       'kropka zgaszona
Do                                                            'napis date, OK-wejscie do ustawien daty
Disp1 = 18                                                    'MODE-nastepna pozycja
Disp2 = 19
Disp3 = 12
Disp4 = 14
  If Ok = 0 Then                                              'ustawienia daty po nacisnieciu OK
     Waiting
     Set_date
  End If

  If Mode1 = 0 Then                                           'kolejna opcja po nacisnieciu MODE
     Waiting
     Goto Menu2
  End If
Loop

Menu2:
Do                                                            'napis TIME
Disp1 = 12
Disp2 = 1
Disp3 = 13
Disp4 = 14
  If Ok = 0 Then                                              'OK-wejscie do ustawien zegarka
     Waiting
     Set_time
  End If

  If Mode1 = 0 Then                                           'MODE-nastepna pozycja w menu
     Waiting
     Goto Menu3
  End If
Loop

Menu3:
Do
Disp1 = 17                                                    'napis ON na disp
Disp2 = 15
Disp3 = 10
Disp4 = 10
  If Ok = 0 Then                                              'jesli wcisniet OK to
     Waiting                                                  'opoznienie
     Set_time_on                                              'ustawienia czasu wlaczenia rejestracji temperatury
  End If

  If Mode1 = 0 Then                                           'jesli wcisnieto MODE to
     Waiting                                                  'opoznienie
     Goto Main                                                'wyjscie z menu
  End If
Loop
'*********************************************************************************************************
Sub Reg                                                       'zapis temperatur do pamieci
                                'zaczynamy od adresu 06(dec)
                                'na poczatek zapisuje godzine rozpoczecia rejestracji
    Ledreg = 1                                                'zgaszenie diody rejestracji

    If Datetime = 1 Then                                      'jesli flaga  ustawiona
       If H = Hon Then                                        'jesli godzina
         If M = Mon Then                                      'i minuta wlaczenia sie zgadza
          Adres = 6                                           'poczatkowy adres
          Wartosc = Month                                     '
          Writee                                              'zapis miesiaca rozpoczecia rejestracji
          Adres = 7                                           '
          Wartosc = Day                                       '
          Writee                                              'zapis dnia rejestracji
          'pod 8 i 9 zapisana godzina i miunta rejestracji
          Datetime = 0                                        'wyzerowanie flagi
          Adresrej = 10                                       'ustawienie adresu rejestracji dla temperatur
          Goto Next_1                                         'skok
         End If
       End If
      Goto Next_3                                             'jesli godzina sie nie zgadza to skok do konca
    End If                                                    'adres bedzie zwiekszony przy zapisie

Next_1:

If Oo2 = 1 Then                                               'zapis tylko raz o danej godzinie
    If M = 0 Then : Oo2 = 0 : Goto Repeat : End If
    If M = 10 Then : Oo2 = 0 : Goto Repeat : End If
    If M = 20 Then : Oo2 = 0 : Goto Repeat : End If
    If M = 30 Then : Oo2 = 0 : Goto Repeat : End If
    If M = 40 Then : Oo2 = 0 : Goto Repeat : End If
    If M = 50 Then : Oo2 = 0 : Goto Repeat : End If
End If

    Goto Next_3

Repeat:
       Gettemp                                                'zmierz temperature
         If Err = 1 Then                                      'jesli blad to
            Incr Count1                                       'zwieksz licznik pomocniczy
                 If Count1 = 3 Then                           'jesli 3 bledy to
                    T = 3000                                  'zapis temp nieosiagalnej oznacza blad lub brak DS
                    Goto Next_2                               'idz dalej
                 End If                                       'koniec warunku
            Goto Repeat                                       'wroc do pomiaru
         End If                                               'koniec warunku bledu
Next_2:                                                       '/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
       Count1 = 0                                             'zerowanie licznika pomocniczego
       Wartosc = Peek(36)                                     'pobierz starsza czesc integera temperatury
       Adres = Adresrej                                       'ustal adres zapisu
       Writee                                                 'zapisz
       Incr Adresrej                                          'zwieksz adres EEPROM
       Wartosc = Peek(37)                                     'pobierz mlodsza czesc integera temperatury
       Adres = Adresrej                                       'przepisz adres potrzebny do procedury zapisu
       Writee                                                 'zapisz
       Incr Adresrej                                          'zwiekszenie adresu o 1
       Adres = 2 : Wartosc = Adresrej : Writee                'zapis adesu konca danych

Next_3:
    If M = 1 Then : Oo2 = 1 : End If
    If M = 11 Then : Oo2 = 1 : End If
    If M = 21 Then : Oo2 = 1 : End If
    If M = 31 Then : Oo2 = 1 : End If
    If M = 41 Then : Oo2 = 1 : End If
    If M = 51 Then : Oo2 = 1 : End If

   If H = Hoff Then                                           'jesli godzina=godzinie wylaczenia
     If M = Moff Then
      Rejestruj = 0                                           'wylaczenie rejestracji
      Datetime = 1                                            'ustawienie flagi pomocniczej
      Ledreg = 1                                              'wylaczenie diody rejestracji
      Goto Next_5
     End If
   End If

Next_4:
Ledreg = 0                                                    'wlaczenie diody rejestracji
Next_5:
End Sub
'*********************************************************************************************************
Sub Senddata                                                  'procedura wysylania danych do PC
    Disable Timer0                                            'wylacz timer
    P1 = &B10111111                                           'kontrolka
    Anoda1 = 1 : Anoda2 = 0 : Anoda3 = 0 : Anoda4 = 1
    Dot = 1                                                   'wylaczenie kropki
    Degree = 1                                                'znaku C
    Dotdegree = 1                                             'przecinka
    Adres = 6                                                 'ustawienie adresu poczatku danych
Do
    Reade                                                     'odczyt z EEPROM     /\/\/\/\/\/\/\/\/\/\/\/\/\/\/
    Poke 38 , Wartosc                                         'wpakowanie do bufora/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
    Incr Adres                                                'to sam dla mlodszej czesci
    Reade
    Poke 39 , Wartosc
    Incr Adres

    Printbin Rsbuf;                                           'wyslanie danej
    If Adres = Adresrej Then                                  'jesli adres wyslany=wartosci zapisanej jako koniec
       Exit Do                                                'wyjscie z petli wysylania
    End If
Loop
    Rsbuf = 2500
    Printbin Rsbuf;                                           'wyslij
    Enable Timer0                                             'wlacz timer
End Sub
'*********************************************************************************************************
Sub Sendtemp                                                  'wysylanie aktualnej temperatury
    Gettemp
    Rsbuf = T
    Printbin Rsbuf;                                           'na kabel :)
End Sub
'*********************************************************************************************************
Sub Gettime                                                   'odczyt z zegarka
I2cstart                                                      'skundy,minuty,godziny,dnia i miesiaca
I2cwbyte 162
I2cwbyte 2
I2cstart
I2cwbyte 163
I2crbyte S , Ack
I2crbyte M , Ack
I2crbyte H , Ack
I2crbyte Day , Ack
I2crbyte Month , Nack
I2cstop
S = Makedec(s) : M = Makedec(m) : H = Makedec(h)
Day = Makedec(day) : Month = Makedec(month)
End Sub
'*********************************************************************************************************
Sub Showtime
Disp1 = H / 10                                                'wyswietla godzine oraz minute
Disp2 = H Mod 10
Disp3 = M / 10
Disp4 = M Mod 10
End Sub
'*********************************************************************************************************
Sub Settings
Dot = 1                                                       'wylacz kropke
Do
Disp1 = H1 / 10
Disp2 = H1 Mod 10
Disp3 = 10
Disp4 = 10
 If Up = 0 Then
  Waiting
  Incr H1
   If H1 = 24 Then
   H1 = 0
   End If
 End If
   If Down = 0 Then
     If H1 = 0 Then
      H1 = 24
     End If
    Waiting
    Decr H1
   End If
     If Ok = 0 Then
      Waiting
      Dot = 0                                                 'wlacz kropke
      Goto Settings1
     End If
Loop
Settings1:
Do
Disp3 = H2 / 10
Disp4 = H2 Mod 10

 If Up = 0 Then
    Waiting
    H2 = H2 + 10
      If H2 = 60 Then
         H2 = 0
      End If
 End If

 If Down = 0 Then
     If H2 = 0 Then
        H2 = 60
     End If
    Waiting
    H2 = H2 - 10
 End If

 If Ok = 0 Then
    Exit Do
 End If
Loop
End Sub
'*********************************************************************************************************
Sub Set_time                                                  'ustawienia czasu
Dot = 1                                                       'wylacz kropke
Do
Disp1 = H / 10
Disp2 = H Mod 10
Disp3 = 10
Disp4 = 10
 If Up = 0 Then
  Waiting
  Incr H
   If H = 24 Then
   H = 0
   End If
 End If
   If Down = 0 Then
     If H = 0 Then
      H = 24
     End If
    Waiting
    Decr H
   End If
     If Ok = 0 Then
      Waiting
      Dot = 0                                                 'wlacz kropke
      Goto Settime1
     End If
Loop
Settime1:
Do
Disp3 = M / 10
Disp4 = M Mod 10

 If Up = 0 Then
    Waiting
    Incr M
      If M = 60 Then
         M = 0
      End If
 End If

 If Down = 0 Then
     If M = 0 Then
        M = 60
     End If
    Waiting
    Decr M
 End If

 If Ok = 0 Then
    Exit Do
 End If
Loop
    S = 0
    S = Makebcd(s) : M = Makebcd(m) : H = Makebcd(h)
    I2cstart
    I2cwbyte 162
    I2cwbyte 2
    I2cwbyte S : I2cwbyte M : I2cwbyte H
    I2cstop
    Demo : Waiting
    Dot = 1
    Goto Menu2
End Sub
'*********************************************************************************************************
Sub Set_time_on                                               'ustawianie czasu wlaczenia rejestracji temperatury
    H1 = Hon : H2 = 0
    Settings
    Hon = H1 : Mon = H2
    Adres = 8 : Wartosc = Hon : Writee
    Adres = 9 : Wartosc = Mon : Writee
    Dot = 1
    Demo : Waiting
    Disp1 = 17                                                'napis Off na disp
    Disp2 = 20
    Disp3 = 20
    Disp4 = 10
    Wait 1
    H1 = Hoff : H2 = 0
    Settings
    Hoff = H1 : Moff = H2
    Adres = 0 : Wartosc = Hoff : Writee
    Adres = 1 : Wartosc = Moff : Writee
    Dot = 1
    Demo : Waiting
    Goto Menu3
End Sub
'*********************************************************************************************************
Sub Set_date                                                  'ustawianie daty
Dot = 1                                                       'wylacz kropke
Do
Disp1 = Month / 10
Disp2 = Month Mod 10
Disp3 = 10
Disp4 = 10
 If Up = 0 Then
  Waiting
  Incr Month
   If Month = 13 Then
   Month = 1
   End If
 End If
   If Down = 0 Then
     If Month = 1 Then
      Month = 13
     End If
    Waiting
    Decr Month
   End If
     If Ok = 0 Then
      Waiting
      Dot = 0                                                 'wlacz kropke
      Goto Set_date_next1
     End If
Loop
Set_date_next1:
Do
Disp3 = Day / 10
Disp4 = Day Mod 10

 If Up = 0 Then
    Waiting
    Incr Day
      If Day = 32 Then
         Day = 1
      End If
 End If

 If Down = 0 Then
     If Day = 1 Then
        Day = 32
     End If
    Waiting
    Decr Day
 End If

 If Ok = 0 Then
    Day = Makebcd(day)
    Month = Makebcd(month)
    I2cstart
    I2cwbyte 162
    I2cwbyte 0
    I2cwbyte 8
    I2cstop
    I2cstart
    I2cwbyte 162
    I2cwbyte 5
    I2cwbyte Day : I2cwbyte Month
    I2cstop
    Demo
    Waiting
    Goto Menu
 End If
Loop
End Sub
'*********************************************************************************************************
Sub Showsettings                                              'pokazuje czas wlaczenia rejestracji temperatury
Dot = 1                                                       'wylacz kropke
Dotdegree = 1
Degree = 1
Disp1 = 17                                                    'o
Disp2 = 15                                                    'n
Disp3 = 10                                                    'puste
Disp4 = 10                                                    'puste
Shortwait
Dot = 0                                                       'wlacz kropke
Disp1 = Hon / 10                                              'pokaz czas wlaczenia rejestracji
Disp2 = Hon Mod 10
Disp3 = Mon / 10
Disp4 = Mon Mod 10
Longwait

Dot = 1                                                       'wylacz kropke
Disp1 = 17                                                    'o
Disp2 = 20                                                    'F
Disp3 = 20                                                    'F
Disp4 = 10                                                    'puste
Shortwait
Dot = 0                                                       'wlacz kropke
Disp1 = Hoff / 10                                             'pokaz czas wylaczenia rejestracji
Disp2 = Hoff Mod 10
Disp3 = Moff / 10
Disp4 = Moff Mod 10
Longwait

End Sub
'*********************************************************************************************************
Sub Showtemp
    Dot = 1                                                   'wyl kropke
 If Err = 1 Then                                              'jezeli blad (brak czujnika) wyswietla "--"
    Disp1 = 11                                                '--
    Disp2 = 11                                                '--
    Disp3 = 11                                                '--
    Disp4 = 11                                                '--
 Else
    Dotdegree = 0
    Degree = 0                                                'znak*C
    Tmp1 = T / 100                                            'setki w tmp1
    Disp2 = Abs(tmp1)                                         'setki na disp
    Tmp2 = T Mod 100                                          'dziesiatki w tmp2
    Tmp1 = Tmp2 / 10                                          '
    Disp3 = Abs(tmp1)                                         'dziesiatki na disp3
    Tmp1 = Tmp2 Mod 10
    Disp4 = Abs(tmp1)
    If Disp2 = 0 Then                                         'likwidacja nieistotnego zera
       Disp2 = 10
    End If
 End If
 If T < 0 Then                                                'jezeli temperatura ujemna to
    Disp1 = 11                                                'na pierwszym wyswietlaczu minus
 Else
    Disp1 = 10                                                'w innym przypadku wygas pierwszy
 End If

End Sub                                                       'powrot
'*********************************************************************************************************
Sub Gettemp                                                   'pobiera i pokazuje temperature
 1wwrite &HCC
 1wwrite &H44
 Waiting : Waiting : Waiting                                  'opoznienie dla konwersji
 Read1820                                                     'odczyt Dallasa
End Sub
'*********************************************************************************************************
Sub Read1820                                                  'odczyt Dallasa
 Disable Interrupts                                           'wylaczenie przerwan
 1wreset                                                      'reset magistrali
 1wwrite &HCC
 1wwrite &HBE
 Bd(1) = 1wread(9)                                            'odczyt wartosci rejestrow
 Enable Interrupts                                            'wlaczenie przerwan
 1wreset                                                      'reset magistrali
 Tmp1 = Bd(1) And 1                                           'obliczenia temperatury
 If Tmp1 = 1 Then Decr Bd(1)
 T = Makeint(bd(1) , Bd(2))
 T = T * 50 : T = T - 25 : T1 = Bd(8) - Bd(7) : T1 = T1 * 100
 T1 = T1 / Bd(8) : T = T + T1 : T = T / 10                    'temperatura w zmiennej T
End Sub
'*********************************************************************************************************
Sub Demo                                                      'pokazuje cztery poziome kreski
  Dot = 1
  Disp1 = 11
  Disp2 = 11
  Disp3 = 11
  Disp4 = 11
  Waiting : Waiting                                           'opoznienie
End Sub
'*********************************************************************************************************
Sub Waiting                                                   'procedura opoznienia (zmniejsz. zajmowanego FLASH)
  Waitms 200
End Sub
'*********************************************************************************************************
Sub Shortwait
    Wait 1
End Sub
'*********************************************************************************************************
Sub Longwait
    Wait 2
End Sub
'*********************************************************************************************************
Sub Writee                                                    ' zapis danych do eeprom
  I2cstart
  I2cwbyte 174
  I2cwbyte Adres
  I2cwbyte Wartosc
  I2cstop
  Waitms 15
End Sub
'*********************************************************************************************************
Sub Reade                                                     ' odczyt danych z eeprom
  I2cstart
  I2cwbyte 174
  I2cwbyte Adres
  I2cstart
  I2cwbyte 175
  I2crbyte Wartosc , 9
  I2cstop
End Sub
'*********************************************************************************************************
Timer0_int:                                                   'przerwanie obslugujace wyswietlacze
 Counter0 = 61500
 Start Timer0
 P3 = P3 Or &B00111100
   If X = 0 Then
      Bufor = Disp1
      Gosub 7seg
      Reset Anoda1
   End If
   If X = 1 Then
      Bufor = Disp2
      Gosub 7seg
      Reset Anoda2
   End If
   If X = 2 Then
      Bufor = Disp3
      Gosub 7seg
      Reset Anoda3
   End If
   If X = 3 Then
      Bufor = Disp4
      Gosub 7seg
      Reset Anoda4
   End If
 Incr X
  If X = 4 Then
     X = 0
  End If

 Incr Count2                                                  'licznik uzywany przy miganiu kropki

Return

7seg:
P1 = Lookup(bufor , Tabela)
Return

Tabela:
Data 192 , 249 , 164 , 176 , 153 , 146 , 130 , 248 , 128 , 144 , 255 , 191 , 206 , 200 , 134 , 171 , 199 , 163 , 161 , 136 , 142
'     0     1     2     3     4     5     6     7     8     9    nic    -     t     m     e     n     L     o     d     A     F
'                                                                      11    12    13    14    15    16    17    18    19    20