'******************************************  *************************************
'****                                  ****  ****                             ****
'**** PROGRAM REJESTRATORA TEMPERATURY ****  ****     MAPA PAMIECI EEPROM     ****
'****                                  ****  ****                             ****
'**** Autor: Piotr Wilk                ****  **** 00-godzina wl. rejestr.     ****
'****        piotr.wilk@poczta.fm      ****  **** 01-dlugosc rejestr.         ****
'****        604791845                 ****  **** 02-adres ostatniej komorki  ****
'****                                  ****  **** 03-godzina wyl rejestr.     ****
'**** Data:  08.09 - 05.11.2003        ****  ****                             ****
'****                                  ****  **** 10-miesiac                  ****
'**** Rozmiar: 3570B                   ****  **** 11-dzien                    ****
'****                                  ****  **** 12-godzina poczatku zapisu  ****
'**** Ver 1.7                          ****  **** 13-minuta poczatku zapisu   ****
'****                                  ****  ****                             ****
'******************************************  *************************************

$large
$crystal = 11059200
$baud = 4800
Config Scl = P2.6
Config Sda = P2.7
Config 1wire = P0.7
Config Timer0 = Timer , Gate = Internal , Mode = 1       'wyswietacze
Load Timer0 , 15375             'WYSWIETLACZE
On Timer0 Timer0_int
Enable Interrupts
Enable Timer0
Start Timer0                    'START TIMERA CZASU

Dim Flag As Bit                 'przelaczanie czas/temp
Dim Onlyone As Bit              'jednokrotny pomiar T na 5 s.
Dim Rejestruj As Bit            'rejestracja
Dim First As Bit                'zapisywanie czasu i daty w EEPROM
Dim Disp1 As Byte               'pierwszy wyswietlacz
Dim Disp2 As Byte               'drugi wyswietlacz
Dim Disp3 As Byte               'trzeci wyswietlacz
Dim Disp4 As Byte               'czwarty wyswietlacz
Dim Bufor As Byte               'bufor wyswietlaczy
Dim X As Byte                   'licznik przy obsludze wyswietlaczy
Dim Adres As Byte               'adres wysylanego bajtu do EEPROM
Dim Wartosc As Byte             'wartosc wysylanego bajtu do EEPROM
Dim H As Byte                   'godzina
Dim M As Byte                   'minuta
Dim S As Byte                   'sekunda
Dim Day As Byte                 'dzien
Dim Month As Byte               'miesiac
Dim Hon As Byte                 'godzina wlaczenia
Dim Hoff As Byte                'godzina wylaczenia
Dim Hlong As Byte               'ilos godzin rejestracji
Dim Adresrej As Byte            'adres ostatniej rejestracji w EEPROM
Dim Tmp As Byte                 'pomocnicza przy wyswietlaniu czasu
Dim Tmp1 As Integer             '|
Dim Tmp2 As Integer             '|pomocnicze przy wyswietlaniu temperatury
Dim T As Integer                'temperatura
Dim T1 As Integer               'pomocnicza przy obliczaniu temperatury
Dim Count1 As Byte              '|
Dim Count2 As Byte              '|liczniki pomocnicze
Dim Count3 As Byte              'licznik do obliczania czasu rejestrowania
Dim Bd(9) As Byte               'pomocnicze przy liczeniu temperatury
Dim Rsbuf As Integer            'bufor transmisji szeregowej
Dim H1 As Byte                  '|zmienne uzywane przy skladania wartosci integer
Dim H2 As Byte                  '|do bufora RS232
Dim Endtrans As Integer

Declare Sub Writee              'zapis do EEPROM
Declare Sub Reade               'odczyt z EEPROM
Declare Sub 7seg                'odczyt tablicy z kodami cyfr
Declare Sub Waiting             'opoznienie
Declare Sub Demo                'kreski na disp
Declare Sub Gettime             'czyta z PCF-a
Declare Sub Showtime            'pokazuje czas
Declare Sub Set_date            'ustaianie daty
Declare Sub Set_time            'ustawianie czasu
Declare Sub Set_time_on         'ustawianie godziny wlaczenia
Declare Sub Set_long            'ustawianie dlugosci rejestracji
Declare Sub Calculate_hoff      'obliczenia godziny wylaczenia ukladu
Declare Sub Showsettings        'pokazanie czasu wlaczenia i wylaczenia rej.
Declare Sub Gettemp             'pobranie temp z czujnika
Declare Sub Showtemp            'wyswietlenie temperatury
Declare Sub Read1820            'odczyt czujnika
Declare Sub Reg                 'zapis temperatury
Declare Sub Senddata            'wysylanie danych do PC
Declare Sub Sendtemp            'wysylanie do PC samej temperatury

Anoda1 Alias P3.2
Anoda2 Alias P3.3
Anoda3 Alias P3.4
Anoda4 Alias P3.5
Degree Alias P3.6

Dot Alias P2.5
Dotdegree Alias P2.4
Ledreg Alias P3.7

Up Alias P2.0
Down Alias P2.1
Ok Alias P2.2
Mode1 Alias P2.3

'*********************************************************************************
Adres = 0 : Reade : Hon = Wartosc       'zcztanie wartosci z EEPROM
Adres = 1 : Reade : Hlong = Wartosc
Adres = 2 : Reade : Adresrej = Wartosc
Adres = 3 : Reade : Hoff = Wartosc
Calculate_hoff                  'przeliczenie godziny wylaczenia
Count3 = 0
Rejestruj = 0                   'wyzerowanie-brak rejestracji
First = 1                       'ustawienie flagi-zapis czasu i daty na poczatku
'\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
'\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ PETLA GLOWNA \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
'\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
Main:
Flag = 1
Onlyone = 1
Do

If S = 10 Or S = 30 Or S = 50 Then
   Flag = 0
End If

If Flag = 0 Then
   Gettime
   If S = 15 Or S = 35 Or S = 55 Then
      Flag = 1
   End If
     If Onlyone = 1 Then
        Gettemp
        Onlyone = 0
     End If
   Showtemp
End If

If Flag = 1 Then
   Onlyone = 1
   Degree = 1
   Dotdegree = 1
   Gettime
   Showtime
   If Count2 > 120 Then         'miganie kropek
      Count2 = 0
      Dot = Not Dot
   End If
End If

If Ok = 0 Then                  'pokaz temperature
   Waiting                      'opoznienie
   Gettemp                      'pobierz temp
   Showtemp                     'pokaz temperature
   Wait 2                       '2 sekundy
   Degree = 1                   'wylaczenie stopni c
   Dotdegree = 1                'wylacz przecinek
End If

If Mode1 = 0 Then               'wejscie do menu
   Waiting
   Goto Menu
End If

If Up = 0 Then                  'pokazuje czas wlaczenia i wylaczenia rejestracji
   Showsettings
End If

If Down = 0 Then                'wlaczanie/wylaczanie rejestracji
   Waiting : Waiting

   If Rejestruj = 0 Then        'jesli bit wlaczajacy wyzerowany
      Rejestruj = 1             'ustaw bit
      Ledreg = 0                'wlaczenie diody
   Else
      Ledreg = 1
      Rejestruj = 0
      First = 1
      Count3 = 0
   End If

End If

If Rejestruj = 1 Then           'jesli ustawiona flaga to rejestruj temperature
   Reg
End If


Rsbuf = Inkey                   '|
                                '|
      If Rsbuf = 1 Then         '|
         Senddata               '|
      End If                    '|odbior danych z RS
                                '|
      If Rsbuf = 2 Then         '|
         Sendtemp               '|
      End If                    '|
                                '|
      If Rsbuf = 3 Then         '|czy uklad podlaczony??
         Endtrans = 3           '|odpowiedz dla PC
         Printbin Endtrans      '|
      End If                    '|

Loop                            'koniec petli glownej

End                             'koniec programu
'/////////////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////////////

Menu:                           'MENU
Dotdegree = 1
Degree = 1
Dot = 1                         'kropka zgaszona
Do                              'napis date, OK-wejscie do ustawien daty
Disp1 = 18                      'MODE-nastepna pozycja
Disp2 = 19
Disp3 = 12
Disp4 = 14
  If Ok = 0 Then
     Waiting
     Set_date
  End If

  If Mode1 = 0 Then
     Waiting
     Goto Menu2
  End If
Loop

Menu2:
Do                              'napis time, OK-wejscie do ustawien zegarka
Disp1 = 12                      'MODE-nastepna pozycja
Disp2 = 1
Disp3 = 13
Disp4 = 14
  If Ok = 0 Then
     Waiting
     Set_time
  End If

  If Mode1 = 0 Then
     Waiting
     Goto Menu3
  End If
Loop

Menu3:
Do
Disp1 = 17                      'napis ON na disp
Disp2 = 15
Disp3 = 10
Disp4 = 10
  If Ok = 0 Then                'jesli wcisniet OK to
     Waiting                    'opoznienie
     Set_time_on                'ustawienia czasu wlaczenia rejestracji temperatury
  End If

  If Mode1 = 0 Then             'jesli wcisnieto mode to
     Waiting                    'opoznienie
     Goto Menu4                 'skok do nastepnej pozycji menu
  End If
Loop

Menu4:                          'napis LONG, OK-wejscie do ustawien dlug. rejestr.
Do                              'MODE-nastepna pozycja
Disp1 = 16
Disp2 = 17
Disp3 = 15
Disp4 = 9
  If Ok = 0 Then
     Waiting
     Set_long                   'ustawienia dlugosci rejestracji
  End If

  If Mode1 = 0 Then             'jesli nacisnieto mode to
     Waiting                    'opoznienie
     Goto Main                  'skok do petli glownej
  End If
Loop
'*********************************************************************************************************
Sub Reg                         'zapis temperatur do pamieci
                                'zaczynamy od adresu 10(dec)
                                'na poczatek zapisuje godzine rozpoczecia rejestracji
    Ledreg = 1                  'zgaszenie diody rejestracji

    If First = 1 Then           'jesli flaga  ustawiona to
       If H = Hon Then          'jesli godzina wlaczenia sie zgadza to
          Adres = 10            'poczatkowy adres
          Wartosc = Month       'miesiac
          Writee                'zapis do EEPROM miesiaca
          Adres = 11            'kolejny adres
          Wartosc = Day         'dzien
          Writee                'zapis do EEPROM dnia
          Adres = 12
          Wartosc = H
          Writee
          Adres = 13
          Wartosc = 0
          Writee
          First = 0             'wyzerowanie flagi
          Adresrej = 14         'ustawienie adresu rejestracji dla temperatur
          Goto Next_1           'skok
        End If
        Goto Next_3             'jesli godzina sie nie zgadza to skok do konca
    End If                      'adres bedzie zwiekszony przy zapisie

Next_1:
    If M = Count3 Then
       Count3 = Count3 + 15
                If Count3 = 60 Then
                   Count3 = 0
                End If

Repeat:
       Gettemp                  'zmierz temperature
         If Err = 1 Then        'jesli blad to
            Incr Count1         'zwieksz licznik pomocniczy
                 If Count1 = 3 Then       'jesli 3 bledy to
                    T = 300     'zapis temp nieosiagalnej oznacza blad lub brak DS
                    Goto Next_2       'idz dalej
                 End If         'koniec warunku
            Goto Repeat         'wroc do pomiaru
         End If                 'koniec warunku bledu
Next_2:
       Count1 = 0               'zerowanie licznika pomocniczego
       Wartosc = Peek(56)       'pobierz starsza czesc integera temperatury
       Adres = Adresrej         'ustal adres zapisu
       Writee                   'zapisz
       Incr Adresrej            'zwieksz adres EEPROM
       Wartosc = Peek(57)       'pobierz mlodsza czesc integera temperatury
       Adres = Adresrej         'przepisz adres potrzebny do procedury zapisu
       Writee                   'zapisz
       Incr Adresrej            'zwiekszenie adresu o 1
       Adres = 2 : Wartosc = Adresrej : Writee       'zapis konca danych

End If

   If H = Hoff Then             'jesli godzina=godzinie wylaczenia
      Rejestruj = 0             'wylaczenie rejestracji
      First = 1
      Count3 = 0
      Ledreg = 1                'wylaczenie diody rejestracji
      Goto Next_4
   End If

Next_3:
Ledreg = 0                      'wlaczenie diody rejestracji
Next_4:
End Sub
'*********************************************************************************************************
Sub Senddata                    'procedura wysylania danych do PC

    Disable Timer0
    P1 = &B10111111             'kontrolka
    Anoda1 = 1 : Anoda2 = 0 : Anoda3 = 0 : Anoda4 = 1
    Dot = 1                     'wylaczenie kropki
    Degree = 1                  'znaku C
    Dotdegree = 1               'przecinka
    Adres = 10
Do
    Reade
    H1 = Wartosc
    Incr Adres
    Reade
    H2 = Wartosc
    Incr Adres

    Poke 72 , H1                'zapisuje do bufora
    Poke 73 , H2                'w razie zmian w RAM-ie uwzglednic miejsce
    Printbin Rsbuf              'zmiennej RSbuf
    Waitms 80
    If Adres = Adresrej Then
       Exit Do
    End If
Loop
    Endtrans = 2220             'flaga konca transmisji przez RS
    Printbin Endtrans           'wyslij na kabel :)
    Enable Timer0
End Sub
'*********************************************************************************************************
Sub Sendtemp

    Gettemp
    Rsbuf = T
    Printbin Rsbuf              'poszlo na kabel :)

End Sub
'*********************************************************************************************************
Sub Gettime                     'odczyt z zegarka
I2cstart
I2cwbyte 162
I2cwbyte 2
I2cstart
I2cwbyte 163
I2crbyte S , Ack
I2crbyte M , Ack
I2crbyte H , Ack
I2crbyte Day , Ack
I2crbyte Month , Nack
I2cstop
S = Makedec(s) : M = Makedec(m) : H = Makedec(h)
Day = Makedec(day) : Month = Makedec(month)
End Sub
'*********************************************************************************************************
Sub Showtime
Disp1 = H / 10                  'obliczenia do wyswietlania
Disp2 = H Mod 10
Disp3 = M / 10
Disp4 = M Mod 10
End Sub
'*********************************************************************************************************
Sub Set_time                    'ustawienia czasu
Dot = 1                         'wylacz kropke
Do
Disp1 = H / 10
Disp2 = H Mod 10
Disp3 = 10
Disp4 = 10
 If Up = 0 Then
  Waiting
  Incr H
   If H = 24 Then
   H = 0
   End If
 End If
   If Down = 0 Then
     If H = 0 Then
      H = 24
     End If
    Waiting
    Decr H
   End If
     If Ok = 0 Then
      Waiting
      Dot = 0                   'wlacz kropke
      Goto Ust_czas_dal1
     End If
Loop
Ust_czas_dal1:
Do
Disp3 = M / 10
Disp4 = M Mod 10

 If Up = 0 Then
    Waiting
    Incr M
      If M = 60 Then
         M = 0
      End If
 End If

 If Down = 0 Then
     If M = 0 Then
        M = 60
     End If
    Waiting
    Decr M
 End If

 If Ok = 0 Then
    S = 0
    S = Makebcd(s) : M = Makebcd(m) : H = Makebcd(h)
    I2cstart
    I2cwbyte 162
    I2cwbyte 2
    I2cwbyte S : I2cwbyte M : I2cwbyte H
    I2cstop
    Demo
    Waiting
    Goto Main
 End If
Loop

End Sub
'*********************************************************************************************************
Sub Set_date                    'ustawianie daty
Dot = 1                         'wylacz kropke
Do
Disp1 = Month / 10
Disp2 = Month Mod 10
Disp3 = 10
Disp4 = 10
 If Up = 0 Then
  Waiting
  Incr Month
   If Month = 13 Then
   Month = 1
   End If
 End If
   If Down = 0 Then
     If Month = 1 Then
      Month = 13
     End If
    Waiting
    Decr Month
   End If
     If Ok = 0 Then
      Waiting
      Dot = 0                   'wlacz kropke
      Goto Set_date_next1
     End If
Loop
Set_date_next1:
Do
Disp3 = Day / 10
Disp4 = Day Mod 10

 If Up = 0 Then
    Waiting
    Incr Day
      If Day = 32 Then
         Day = 1
      End If
 End If

 If Down = 0 Then
     If Day = 1 Then
        Day = 32
     End If
    Waiting
    Decr Day
 End If

 If Ok = 0 Then
    Day = Makebcd(day)
    Month = Makebcd(month)
    I2cstart
    I2cwbyte 162
    I2cwbyte 0
    I2cwbyte 8
    I2cstop
    I2cstart
    I2cwbyte 162
    I2cwbyte 5
    I2cwbyte Day : I2cwbyte Month
    I2cstop
    Demo
    Waiting
    Goto Main
 End If
Loop
End Sub
'*********************************************************************************************************
Sub Set_time_on                 'ustawianie czasu wlaczenia rejestracji temperatury
Dot = 0                         'wlacz kropke
Do
Disp1 = Hon / 10                '|
Disp2 = Hon Mod 10
Disp3 = 0                       '|
Disp4 = 0                       '|

 If Up = 0 Then
    Waiting
    Incr Hon
      If Hon = 24 Then
         Hon = 0
      End If
 End If

 If Down = 0 Then
     If Hon = 0 Then
        Hon = 24
     End If
    Waiting
    Decr Hon
 End If

 If Ok = 0 Then
    Calculate_hoff              'obliczanie godziny wylaczenia rejestracji
    Waiting
    Demo                        'kreski na disp
    Adres = 0                   '|
    Wartosc = Hon               '|zapis do EEPROM
    Writee                      '|
    First = 1                   'ustawienie flagi powoduje zapis godziny przed temp.
    Goto Main                   'skok do petli glownej
 End If
Loop
End Sub
'*********************************************************************************************************
Sub Calculate_hoff

    Hoff = Hon

    For Tmp = 1 To Hlong
        Incr Hoff
          If Hoff = 24 Then
             Hoff = 0
          End If
    Next Tmp

End Sub
'*********************************************************************************************************
Sub Set_long                    'ustawianie dlugosci rejestracji
Set Dot
Do
Disp1 = Hlong / 10
Disp2 = Hlong Mod 10
Disp3 = 10
Disp4 = 10

 If Up = 0 Then
  Waiting
  Incr Hlong
   If Hlong = 16 Then
   Hlong = 1
   End If
 End If

   If Down = 0 Then
     If Hlong = 1 Then
        Hlong = 16
     End If
    Waiting
    Decr Hlong
   End If

     If Ok = 0 Then
        Calculate_hoff
        Waiting
        Adres = 1
        Wartosc = Hlong
        Writee
        Demo
        Goto Main
     End If
Loop
End Sub
'*********************************************************************************************************
Sub Showsettings                'pokazuje czas wlaczenia rejestracji temperatury
Dot = 1                         'wylacz kropke
Dotdegree = 1
Degree = 1
Disp1 = 17                      'o
Disp2 = 15                      'n
Disp3 = 10                      'puste
Disp4 = 10                      'puste
Wait 1
Dot = 0                         'wlacz kropke
Disp1 = Hon / 10                'pokaz czas wlaczenia rejestracji
Disp2 = Hon Mod 10
Disp3 = 0
Disp4 = 0
Wait 2

Dot = 1                         'wylacz kropke
Disp1 = 17                      'o
Disp2 = 20                      'F
Disp3 = 20                      'F
Disp4 = 10                      'puste
Wait 1
Dot = 0                         'wlacz kropke
Disp1 = Hoff / 10               'pokaz czas wylaczenia rejestracji
Disp2 = Hoff Mod 10
Disp3 = 0
Disp4 = 0
Wait 2

End Sub
'*********************************************************************************************************
Sub Showtemp
    Dot = 1                     'wyl kropke
 If Err = 1 Then                'jezeli blad (brak czujnika) wyswietla "--"
    Disp1 = 11                  '--
    Disp2 = 11                  '--
    Disp3 = 11                  '--
    Disp4 = 11                  '--
 Else
    Dotdegree = 0
    Degree = 0                  'znak*C
    Tmp1 = T / 100              'setki w tmp1
    Disp2 = Abs(tmp1)           'setki na disp
    Tmp2 = T Mod 100            'dziesiatki w tmp2
    Tmp1 = Tmp2 / 10            '
    Disp3 = Abs(tmp1)           'dziesiatki na disp3
    Tmp1 = Tmp2 Mod 10
    Disp4 = Abs(tmp1)
    If Disp2 = 0 Then           'likwidacja nieistotnego zera
       Disp2 = 10
    End If

 End If

 If T < 0 Then                  'jezeli temperatura ujemna to
    Disp1 = 11                  'na pierwszym wyswietlaczu minus
 Else
    Disp1 = 10                  'w innym przypadku wygas pierwszy
 End If

End Sub                         'powrot
'*********************************************************************************************************
Sub Gettemp                     'pobiera i pokazuje temperature

 Disable Interrupts             'wylaczenie przerwan
 1wwrite &HCC
 1wwrite &H44
 Enable Interrupts              'wlaczenie przerwan
 Waiting : Waiting : Waiting
 Read1820                       'odczyt Dallasa

End Sub
'*********************************************************************************************************
Sub Read1820                    'odczyt Dallasa
 Disable Interrupts             'wylaczenie przerwan
 1wreset                        'reset magistrali
 1wwrite &HCC
 1wwrite &HBE
 Bd(1) = 1wread(9)              'odczyt wartosci rejestrow
 Enable Interrupts              'wlaczenie przerwan
 1wreset                        'reset magistrali
 Tmp1 = Bd(1) And 1             'obliczenia temperatury
 If Tmp1 = 1 Then Decr Bd(1)
 T = Makeint(bd(1) , Bd(2))
 T = T * 50 : T = T - 25 : T1 = Bd(8) - Bd(7) : T1 = T1 * 100
 T1 = T1 / Bd(8) : T = T + T1 : T = T / 10       'temperatura w zmiennej T
End Sub
'*********************************************************************************************************
Sub Demo
  Disp1 = 11
  Disp2 = 11
  Disp3 = 11
  Disp4 = 11
  Waiting : Waiting             'opoznienie
End Sub
'*********************************************************************************************************
Sub Waiting                     'procedura opoznienia (trick zmniejsz. zajmowany FLASH)
  Waitms 200
End Sub
'*********************************************************************************************************
Sub Writee                      ' zapis danych do eeprom
  I2cstart
  I2cwbyte 160
  I2cwbyte Adres
  I2cwbyte Wartosc
  I2cstop
  Waitms 15
End Sub
'*********************************************************************************************************
Sub Reade                       ' odczyt danych z eeprom
  I2cstart
  I2cwbyte 160
  I2cwbyte Adres
  I2cstart
  I2cwbyte 161
  I2crbyte Wartosc , 9
  I2cstop
End Sub
'*********************************************************************************************************
Timer0_int:                     'przerwanie obslugujace wyswietlacze
 Load Timer0 , 15375            ' dla 65 Hz - 15385
 P3 = P3 Or &B00111100
   If X = 0 Then
      Bufor = Disp1
      Gosub 7seg
      Reset Anoda1
   End If
   If X = 1 Then
      Bufor = Disp2
      Gosub 7seg
      Reset Anoda2
   End If
   If X = 2 Then
      Bufor = Disp3
      Gosub 7seg
      Reset Anoda3
   End If
   If X = 3 Then
      Bufor = Disp4
      Gosub 7seg
      Reset Anoda4
   End If
 Incr X
  If X = 4 Then
     X = 0
  End If

 Incr Count2                    'licznik uzywany przy miganiu

Return

7seg:
P1 = Lookup(bufor , Tabela)
Return

Tabela:
Data 192 , 249 , 164 , 176 , 153 , 146 , 130 , 248 , 128 , 144 , 255 , 191 , 206 , 200 , 134 , 171 , 199 , 163 , 161 , 136 , 142
'     0     1     2     3     4     5     6     7     8     9    nic    -     t     m     e     n     L     o     d     A     F
'                                                                      11    12    13    14    15    16    17    18    19    20